

/*@ requires \valid_index(t,i) &&  \valid_index(t,j)
  @ assigns t[i],t[j]
  @ ensures t[i] == \old(t[j]) && t[j] == \old(t[i])
  @*/
void swap(int t[],int i,int j) {
  int tmp = t[i];
  t[i] = t[j];
  t[j] = tmp;
}


/* Quicksort Partition Function */

/*@ requires 0 <= p <= r && \valid_range(A,p,r)  
  @ ensures  
  @      p <= \result <= r && 
  @      (\forall int l; p <= l < \result => A[l] <= A[\result]) && 
  @      (\forall int l; \result < l <= r => A[l] >  A[\result]) && 
  @      A[\result] == \old(A[r]) 
  @*/
int partition (int A[], int p,int r) 
{ 
  int x = A[r]; 
  int tmp, j, i = p-1; 
  /*@ invariant 
    @    p <= j <= r && p-1 <= i < j && 
    @    ((\forall int k; (p <= k <= i) => A[k] <= x)) &&
    @    ((\forall int k; (i <  k <  j) => A[k] >  x)) &&
    @    A[r] == x 
    @ variant (r-j)
    @*/
  for(j=p; j<r; j++) 
    if (A[j] <= x) { 
      i++; 
      swap(A,i,j);
    } 
  swap(A,i+1,r);
  return i+1; 
}


