# this makefile was automatically generated; do not edit 

TIMEOUT ?= 10

WHY=why --no-arrays 

GWHY=gwhy --no-arrays 

CADULIB=/usr/local/lib/caduceus

CADULIBFILE=caduceus.why

COQTACTIC=intuition; subst; auto

COQDEP=coqdep -I `coqc -where`/user-contrib

.PHONY: all coq pvs simplify cvcl harvey smtlib zenon

all: simplify/quicksort__partition_why.sx\
  simplify/quicksort__swap_why.sx\
  simplify/quicksort__quicksort_why.sx

coq: coq.depend coq/quicksort__partition_why.vo\
  coq/quicksort__swap_why.vo\
  coq/quicksort__quicksort_why.vo

coq/%_spec_why.v: why/%_spec.why
	@echo 'why -coq-v8 [...] why/$*_spec.why' && $(WHY) -coq-v8 -dir coq -coq-preamble "Require Export Caduceus." $(CADULIB)/why/$(CADULIBFILE) why/$*_spec.why

coq/%_why.v: why/quicksort_spec.why why/%.why
	@echo 'why -coq-v8 [...] why/$*.why' &&$(WHY) -coq-v8 -dir coq -coq-preamble "Require Export quicksort_spec_why." -coq-tactic "$(COQTACTIC)" $(CADULIB)/why/$(CADULIBFILE) why/quicksort_spec.why why/$*.why

coq/%.vo: coq/%.v
	coqc -I coq $<

pvs: pvs/quicksort_spec_why.pvs pvs/quicksort__partition_why.pvs\
  pvs/quicksort__swap_why.pvs\
  pvs/quicksort__quicksort_why.pvs

pvs/%_spec_why.pvs: why/%_spec.why
	$(WHY) -pvs -dir pvs -pvs-preamble "importing why@why" $(CADULIB)/why/$(CADULIBFILE) why/$*_spec.why

pvs/%_why.pvs: pvs/quicksort_spec_why.pvs why/%.why
	$(WHY) -pvs -dir pvs -pvs-preamble "importing quicksort_spec_why" $(CADULIB)/why/$(CADULIBFILE) why/quicksort_spec.why why/$*.why

pvs/caduceus_why.pvs:
	$(WHY) -pvs -dir pvs $(CADULIB)/why/$(CADULIBFILE)

isabelle: isabelle/quicksort__partition_why.thy isabelle/quicksort__partition_spec_why.thy\
  isabelle/quicksort__swap_why.thy isabelle/quicksort__swap_spec_why.thy\
  isabelle/quicksort__quicksort_why.thy isabelle/quicksort__quicksort_spec_why.thy

isabelle/%_spec_why.thy: why/%_spec.why
	$(WHY) -isabelle -dir isabelle -isabelle-base-theory caduceus_why $(CADULIB)/why/$(CADULIBFILE) why/$*_spec.why

isabelle/%_why.thy: isabelle/quicksort_spec_why.thy why/%.why
	$(WHY) -isabelle -dir isabelle -isabelle-base-theory quicksort_spec_why $(CADULIB)/why/$(CADULIBFILE) why/quicksort_spec.why why/$*.why
	cp -f /usr/local/lib/caduceus/isabelle/caduceus_why.thy isabelle/

simplify: simplify/quicksort__partition_why.sx\
  simplify/quicksort__swap_why.sx\
  simplify/quicksort__quicksort_why.sx
	@echo 'Running Simplify on proof obligations' && (dp -timeout $(TIMEOUT) $^)

simplify/%_why.sx: why/quicksort_spec.why why/%.why
	@echo 'why -simplify [...] why/$*.why' && $(WHY) -simplify -no-simplify-prelude -dir  simplify $(CADULIB)/why/$(CADULIBFILE) why/quicksort_spec.why why/$*.why

goals: why/quicksort__partition_ctx.why\
  why/quicksort__swap_ctx.why\
  why/quicksort__quicksort_ctx.why

why/%_ctx.why: why/quicksort_spec.why why/%.why
	@echo 'why --multi-why [...] why/$*.why' && $(WHY) --multi-why -dir why $(CADULIB)/why/$(CADULIBFILE) why/quicksort_spec.why why/$*.why

why/%_why.why: why/quicksort_spec.why why/%.why
	@echo 'why -why [...] why/$*.why' && $(WHY) -why -dir why $(CADULIB)/why/$(CADULIBFILE) why/quicksort_spec.why why/$*.why

cvcl: cvcl/quicksort__partition_why.cvc\
  cvcl/quicksort__swap_why.cvc\
  cvcl/quicksort__quicksort_why.cvc

	@echo 'Running CVC Lite on proof obligations' && (dp -timeout $(TIMEOUT) $^)

cvcl/%_why.cvc: why/quicksort_spec.why why/%.why
	@echo 'why -cvcl [...] why/$*.why' && $(WHY) -cvcl --encoding sstrat -dir cvcl $(CADULIB)/why/$(CADULIBFILE) why/quicksort_spec.why why/$*.why

harvey: harvey/quicksort__partition_why.rv\
  harvey/quicksort__swap_why.rv\
  harvey/quicksort__quicksort_why.rv
	@echo 'Running haRVey on proof obligations' && (dp -timeout $(TIMEOUT) $^)

harvey/%_why.rv: why/quicksort_spec.why why/%.why
	@echo 'why -harvey [...] why/$*.why' && $(WHY) -harvey -dir harvey $(CADULIB)/why/$(CADULIBFILE) why/quicksort_spec.why why/$*.why

zenon: zenon/quicksort__partition_why.znn\
  zenon/quicksort__swap_why.znn\
  zenon/quicksort__quicksort_why.znn
	@echo 'Running Zenon on proof obligations' && (dp -timeout $(TIMEOUT) $^)

zenon/%_why.znn: why/quicksort_spec.why why/%.why
	@echo 'why -zenon [...] why/$*.why' && $(WHY) -zenon -dir zenon $(CADULIB)/why/$(CADULIBFILE) why/quicksort_spec.why why/$*.why

smtlib: smtlib/quicksort__partition_why.smt\
  smtlib/quicksort__swap_why.smt\
  smtlib/quicksort__quicksort_why.smt
	@echo 'Running Yices on proof obligations' && (dp -timeout $(TIMEOUT) $^)

smtlib/%_why.smt: why/quicksort_spec.why why/%.why
	@echo 'why -smtlib [...] why/$*.why' && $(WHY) -smtlib --encoding sstrat -exp all   -dir smtlib $(CADULIB)/why/$(CADULIBFILE) why/quicksort_spec.why why/$*.why

gui stat: quicksort__partition.stat

%.stat: why/quicksort_spec.why why/%.why
	@echo 'gwhy [...] why/$*.why' && $(GWHY) $(CADULIB)/why/$(CADULIBFILE) why/quicksort_spec.why why/$*.why

-include quicksort.depend

coq.depend: coq/quicksort_spec_why.v coq/quicksort__partition_why.v\
  coq/quicksort__swap_why.v\
  coq/quicksort__quicksort_why.v
	-$(COQDEP) -I coq coq/quicksort*_why.v > quicksort.depend

clean:
	rm -f coq/*.vo

